;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w d1#w d2#w H#w H2#w d3#w H4#w L#w H1#w K#w w2#w
			      czyuszczelka#w centr#w blok#w nazwa#w 
                nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w listaPX#w  tbl00#w
		i#w p#w pp#w ppp#w ppp1#w przekrSpec#w wlotwylotx#w nazwaSmay_tu#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / a#w b#w l#w r#w kat#w blok#w nazwadoz#w p#w pp#w ppp#w ppp1#w
						blok1#w nazwadoz1#w p1b#w)

		(setq pp#w (cadr (assoc "WentyleHaltonPRA_model" akcesoria#w)))
		(cond   ((member pp#w '("0"))  (setq ppp#w "N"))
			((member pp#w '("1"))  (setq ppp#w "A"))
		);cond
		(setq blok#w     (strcat "PRA" ppp#w (nth 0 rekord#w))
 		      nazwadoz#w (strcat "PRA" "-" ppp#w "-" (nth 0 rekord#w)))

		(setq pp#w (cadr (assoc "WentyleHaltonPRA_zastos" akcesoria#w)))
		(cond   ((member pp#w '("0"))  (setq ppp#w "N"))
			((member pp#w '("1"))  (setq ppp#w "S"))
		);cond
		(setq blok#w     (strcat blok#w  ppp#w)
 		      nazwadoz#w (strcat nazwadoz#w "<" ppp#w ">"))

		(setq   blok#w  (substr blok#w 1 28))

	             ;blok   nazwa       tytul   uwagi         producent
		(list blok#w nazwadoz#w "Zesp pomiarowo regulacyjny" "" "Halton"  
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun



(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleHalton" "Zesp pomiarowo regulacyjny " "WentyleHaltonPRA"  "PRA"  "Halton" " "   "       " 
            "Okno_wlasneplus_hl" czyedycja#w "" nil
            "WentyleHalton(PRA)"  "WentyleHalton(PRA_11)" "WentyleHalton(PRA_12)" nil nil 
                                  nil nil nil nil 
             (list 	(list "Model:" "WentyleHaltonPRA_model")
			(list "Zastosowanie:" "WentyleHaltonPRA_zastos")) ;listaPlikowDanychWyposaenia
	     (list (list "d1 mm" "") (list "L mm" "")(list "H mm" "")) ;listaWlasnychGabarytw z opisami
            "3" ;ileZlistyDoWlasnych#w 
));master00#w/setq
(wyl_err1#w)




(if zwrot#w  
(progn	

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku  
(setq   rekord#w (nth 5 zwrot#w)
             d1#w (atof (car rekord#w))
             l#w  (atof (cadr rekord#w))
             h#w  (atof (caddr rekord#w))

	 centr#w (nth 14 zwrot#w)
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
  nazwaSmay_tu#w (car (nth 19 zwrot#w))
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 15 zwrot#w))


   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   ;korekta symbolu w danych do edycji
   (setq pp#w (cadr (reverse zwrot#w))
	 zwrot#w (append (reverse (cddr (reverse zwrot#w))) 
		         (list (append (list (cadr p#w)) (cdr pp#w)) (car (reverse zwrot#w))) ))


   ;jeli bd bloki
   (setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\" "WentyleHalton" (nth 11 zwrot#w) "_"))

                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))


(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T))


;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w d1#w l#w h#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w d1#w l#w h#w centr#w czyuszczelka#w nazwa#w)))
);cond


;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))


;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleHalton")

	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja


));progn/if
		
(princ)
);defun








;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w d1#w l#w h#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (car (rysuje11#w samepunkty#w d1#w l#w h#w centr#w czyuszczelka#w nazwa#w)))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)         "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list l#w 0)       "")
));list/setq

ppzwrot#w
);defun







;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w d1#w l#w h#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (car (rysuje12#w samepunkty#w d1#w l#w h#w centr#w czyuszczelka#w nazwa#w)))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)         "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list l#w 0)       "")
));list/setq

ppzwrot#w
);defun







;procedura rysunkowa
(defun rysuje11#w (samepunkty#w d1 l h centr czyuszczelka nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq  pX  (trans '(0 0) 1 0)
	   pY  (trans (list l 0) 1 0) 
           szerkol  (* 0.07 d1)
    );setq 

    (if (> d1 315.0) (setq szerkol (* 0.035 d1)))

    (command "_LINE" '(0 0) (list l 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)
    (command "_PLINE" (list 0 (- (/ d1 2))) (list 0 (/ d1 2)) "_a" 
    (list szerkol (/ d1 2)) "_l" (list szerkol (- (/ d1 2))) "_a" "_cl")
                                                (ssadd (entlast) wskazB)
    (command "_PLINE" (list l (- (/ d1 2))) (list l (/ d1 2)) "_a" 
    (list (- l szerkol) (/ d1 2)) "_l" (list (- l szerkol) (- (/ d1 2))) "_a" "_cl")
                                                            (ssadd (entlast) wskazB)
    (command "_LINE" (list szerkol (- (/ d1 2))) (list (- l szerkol) (- (/ d1 2))) "")
                     (ssadd (entlast) wskazB)
    (command "_LINE" (list szerkol (/ d1 2)) (list (- l szerkol) (/ d1 2)) "")
                     (ssadd (entlast) wskazB)

    (command "_LINE"  (list (* 0.15 l) (- (* 0.15 d1) (* 0.5 d1))) (list (- l (* 0.15 l)) (- (* 0.5 d1) (* 0.15 d1))) "")
		      (ssadd (entlast) wskazB)
    (command "_CIRCLE" (list (* 0.5 l) 0) (* 0.05 d1))(ssadd (entlast) wskazB)


    (command "_UCS" "_o" (list (* 0.5 l) (* 0.52 d1)))
    (command "_LINE" '(0 0) (list 0 h) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)
    (command "_PLINE"  (list (- (* 0.50 h)) 0.0) (list (- (* 0.45 h)) (* 1.00 h)) 
		       (list (* 0.45 h) (* 1.00 h)) (list (* 0.50 h) 0.0) "_c")(ssadd (entlast) wskazB)
    (command "_UCS" "_p")

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0) )(ssadd (entlast) wskazB)
(command "_POINT" (list l 0) )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w

(list pX pY)
);defun 








;procedura rysunkowa
(defun rysuje12#w (samepunkty#w d1 l h centr czyuszczelka nazwa1 
                    / pr wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq  pX  (trans '(0 0) 1 0)
	   pY  (trans (list l 0) 1 0) 
           szerkol  (* 0.07 d1)
    );setq 

    (if (> d1 315.0) (setq szerkol (* 0.035 d1)))

    (command "_LINE" '(0 0) (list l 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)
    (command "_PLINE" (list 0 (- (/ d1 2))) (list 0 (/ d1 2)) "_a" 
    (list szerkol (/ d1 2)) "_l" (list szerkol (- (/ d1 2))) "_a" "_cl")
                                                (ssadd (entlast) wskazB)
    (command "_PLINE" (list l (- (/ d1 2))) (list l (/ d1 2)) "_a" 
    (list (- l szerkol) (/ d1 2)) "_l" (list (- l szerkol) (- (/ d1 2))) "_a" "_cl")
                                                            (ssadd (entlast) wskazB)
    (command "_LINE" (list szerkol (- (/ d1 2))) (list (- l szerkol) (- (/ d1 2))) "")
                     (ssadd (entlast) wskazB)
    (command "_LINE" (list szerkol (/ d1 2)) (list (- l szerkol) (/ d1 2)) "")
                     (ssadd (entlast) wskazB)

    (command "_LINE"  (list (* 0.15 l) (- (* 0.15 d1) (* 0.5 d1))) (list (- l (* 0.15 l)) (- (* 0.5 d1) (* 0.15 d1))) "")
		      (ssadd (entlast) wskazB)
    (command "_CIRCLE" (list (* 0.5 l) 0) (* 0.05 d1))(ssadd (entlast) wskazB)


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0) )(ssadd (entlast) wskazB)
(command "_POINT" (list l 0) )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w

(list pX pY)
);defun 










;druga lokalna procedura sprawdzajca gabaryty wasne, korzysta ze zmiennych procedury nadrzdnej
(defun czy_masterMoj#w ( / text1#w pxx#w j#w a b a1 b1 d1
			   pp#w akceso#w wykon#w mechan#w wyzwalanie#w termik#w)

(progn

(if (and listaWlasnych#w (not text1#w)) (progn
(cond 
((not listaWlas#w)(setq text1#w "Wypenij pola rozmiarw lub wybierz z listy !..."))
(T (progn
   (setq pxx#w '())(foreach j#w listaWlas#w (if (and j#w (/= j#w "")) 
                                                (setq pxx#w (append pxx#w (list j#w)))))
   (if (and listaWlasnych#w (> (length listaWlasnych#w) (length pxx#w)))
                                (setq text1#w "Brakuje wpisu w jednym z pl rozmiarw !..."))
   ));progn+
);cond
));progn/if

(if (and listaWlasnych#w (not text1#w))
	(progn
        (cond
        ;;((sprawdz_lcalk#w (nth 0 pxx#w) 200 630)
        ;;      (setq text1#w "Bdny wpis lub przekroczone granice 200 - 630 w polu d1mm !..."))

	)));progn/if

(if text1#w (set_tile "error" text1#w))

text1#w
));progn/defun

