;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w d1#w l#w czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w kanal#w
		  akcesoria#w  blokOpisUwagi#w listaPX#w i#w p#w pp#w ppp#w sciezkaB#w
		  wlotwylotx#w przekrSpec#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w
						  lamelAtryb#w  rozmiarAtryb#w p#W pp#W ppp#W)
		   (setq  blok#w     (strcat "PJP" (cadr rekord#w) "x" (caddr rekord#w))
		          nazwadoz#w (strcat "PJP " (cadr rekord#w) "x" (caddr rekord#w)))

		(setq pp#w (cadr (assoc "WentyleDarcoPJP_Ciegno" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "" p#w ""))
		      ((member pp#w '("1"))  (setq ppp#w "-C" p#w " z cignem"))
		);cond
		(setq  blok#w     (strcat blok#w ppp#w "-OC")
		       nazwadoz#w (strcat nazwadoz#w ppp#w "-OC"))

		;okrelenie dopiskw do atrybutu - regulacje i rozmiar
		(setq rozmiarAtryb#w nazwadoz#w)
		(setq lamelAtryb#w "")
		(setq pp#w (cadr (assoc "WentyleDarcoPJP_Nastawy" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "nast.5st."))
		      ((member pp#w '("1"))  (setq ppp#w "nast.10st."))
		      ((member pp#w '("2"))  (setq ppp#w "nast.15st."))
		      ((member pp#w '("3"))  (setq ppp#w "nast.20st."))
		      ((member pp#w '("4"))  (setq ppp#w "nast.25st."))
		      ((member pp#w '("5"))  (setq ppp#w "nast.30st."))
		      ((member pp#w '("6"))  (setq ppp#w "nast.35st."))
		      ((member pp#w '("7"))  (setq ppp#w "nast.40st."))
		      ((member pp#w '("8"))  (setq ppp#w "nast.45st."))
		      ((member pp#w '("9"))  (setq ppp#w "nast.50st."))
		      ((member pp#w '("10"))  (setq ppp#w "nast.55st."))
		      ((member pp#w '("11"))  (setq ppp#w "nast.60st."))
		);cond
		(setq lamelAtryb#w (strcat lamelAtryb#w "," ppp#w))

	             ;blok   nazwa      tytul  uwagi         producent
		(list blok#w nazwadoz#w (strcat "Przepustnica" p#w) "" "Darco"  
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleDarco" "Przepustnica " "WentyleDarcoPJP"  "PJP"  "Darco" " "   "    " 
            "Okno_plus_dar" czyedycja#w "" nil "1"
            "WentyleDarco(PJP)" "WentyleDarco(PJP_11)" nil nil nil
                                "WentyleDarco(PJP_21)" nil nil nil 
             (list (list "Kt nastawy (may-zamknicie):" "WentyleDarcoPJP_Nastawy")
		   (list "Cigno:" "WentyleDarcoPJP_Ciegno")) ;listaPlikowDanychWyposaenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)



(if zwrot#w  
(progn 				

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
             a#w (atof (nth 1 rekord#w))
             b#w (atof (nth 2 rekord#w))
	     l#w (* 1.5 b#w)

  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w)
     sciezkaB#w (strcat scd#w (caar zwrot#w) "\\" "WentyleDarcoPJP" 
			(cadr (nth 5 zwrot#w)) "_" ktora#w))

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))
                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

(setq wlotwylotx#w "")

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w sciezkaB#w a#w b#w l#w centr#w nazwa#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w sciezkaB#w a#w b#w l#w centr#w nazwa#w)))

);cond

;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w '(("P1" "axbmm") ("P2" "axbmm"))
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                    ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                    ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(setq  przekrSpec#w pp#w)


;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w  przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w przekrSpec#w)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleDarco")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun






;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w sciezkaB#w a#w b#w l#w centr#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w sciezkaB#w a#w b#w l#w  centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                 ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)      "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list l#w 0) "")
));list/setq

ppzwrot#w
);defun




;procedura porednia rysunkowa
(defun rys21#w (samepunkty#w sciezkaB#w a#w b#w l#w centr#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    ;zamienione miejscami a#w i b#w
    (setq pX#w (rysuje11#w samepunkty#w sciezkaB#w b#w a#w l#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)      "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list l#w 0) "") 
));list/setq

ppzwrot#w
);defun









;procedura rysunkowa
(defun rysuje11#w (samepunkty#w sciezkaB#w a b l centr nazwa1 
                    / pr wskaztu layer szerkol pA pB p0 p1 p2 pX pY pZ styld  rad bb ll )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_LAYER" "_t" layer_zarys "_s" layer_zarys "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq pX (trans '(0 0) 1 0))

     (setq rad (* 0.05 b)
	   bb  (* 0.2 b)
	   ll  (* 0.2 l))

     (command "_PLINE"  (list 0 (* 0.5 b))     (list 0 (- (* 0.5 b))) 
			(list l (- (* 0.5 b))) (list l (* 0.5 b)) "_c")
                        (ssadd (entlast) wskazB)

     (command "_LINE"  (list ll (- bb (* 0.5 b))) (list (- l ll) (- (* 0.5 b) bb)) "")
		       (ssadd (entlast) wskazB)
     (command "_CIRCLE" (list (* 0.5 l) 0) rad)(ssadd (entlast) wskazB)

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ l 2) l) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0))(ssadd (entlast) wskazB)
(command "_POINT" (list l 0))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "")

));progn/if not samepunkty#w

pX
);defun 

