;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w d1#w d3#w l#w h#w czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w listaPX#w
		  i#w p#w pp#w przekrSpec#w sciezkaB#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w)
		(setq  blok#w     (strcat "ACTIVENT"  (car rekord#w)) 
		       nazwadoz#w (strcat "ACTIVENT" " " (car rekord#w)) )

		;uwzgldnienie konfiguracji dysz
		(setq pp#w (cadr (assoc "WentyleFlaktbACT_Dysze" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "360-"))
		      ((member pp#w '("1"))  (setq ppp#w "300-"))
		      ((member pp#w '("2"))  (setq ppp#w "240-"))
		      ((member pp#w '("3"))  (setq ppp#w "180-"))
		      ((member pp#w '("4"))  (setq ppp#w "2x120-"))
		      ((member pp#w '("5"))  (setq ppp#w "2x60-"))
		);cond
		(setq  blok#w     (strcat blok#w ppp#w)
		       nazwadoz#w (strcat nazwadoz#w "-" ppp#w))

		;uwzgldnienie dugoci
		(setq  blok#w     (strcat blok#w (caddr rekord#w))
		       nazwadoz#w (strcat nazwadoz#w (caddr rekord#w) "-"))

		;uwzgldnienie wykonania
		(setq pp#w (cadr (assoc "WentyleFlaktbACT_Mat" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "1"))
		      ((member pp#w '("1"))  (setq ppp#w "2"))
		      ((member pp#w '("1"))  (setq ppp#w "3"))
		);cond
		(setq  blok#w     (strcat blok#w ppp#w)
		       nazwadoz#w (strcat nazwadoz#w ppp#w))

	             ;blok   nazwa      tytul  uwagi         producent
		(list blok#w nazwadoz#w "Nawiewnik " ""  "FLAKT Bovent"  
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleFlaktb" "Nawiewnik " "WentyleFlaktbACT" "ACTIVENT" "FLAKT Bovent" ""   "  " 
            "Okno_plus_fb" czyedycja#w "" nil "1"
            "WentyleFlaktb(ACTIVENT)"  "WentyleFlaktb(ACTIVENT_11)"  nil nil nil
                                  nil nil nil nil
             (list (list "Kt dysz" "WentyleFlaktbACT_Dysze")
		   (list "Materia" "WentyleFlaktbACT_Mat"));listaPlikowDanychWyposaenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            d1#w (atof (cadr rekord#w))
             l#w (atof (caddr rekord#w))
  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w))


   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))


   (setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\" "WentyleFlaktb" 
				  (nth 11 zwrot#w) (cadr (nth 5 zwrot#w)) "-" (caddr (nth 5 zwrot#w)) ))

                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))


(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w sciezkaB#w d1#w l#w centr#w czyuszczelka#w nazwa#w)))
);cond



;dodanie pola przekroju do kadego punktu z ppzwrot#w
;dla zczek, gdzie zdarzaj si rzyty z obcit list punktw
;std ostatni czon liczcy  przekrSpec#w
(setq pp#w '())
(foreach i#w '(("P1" "d1mm") ("P2" "d1mm")("P3" "d1mm"))
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P3" "d1mm"))
        (setq p#w  (/ (/ (* pi (* d1#w d1#w)) 4) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(setq  przekrSpec#w pp#w)


;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w przekrSpec#w)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleSpiro")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w  sciezkaB#w d1#w l#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w sciezkaB#w d1#w l#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0) "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "d1mm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "d1mm" (list l#w 0)       "")
  (list "P3" "d1mm" (list (/ l#w 2) (* 0.6 d1#w)) "")
));list/setq

ppzwrot#w
);defun








;procedura rysunkowa
(defun rysuje11#w (samepunkty#w sciezkaB#w d1 l centr czyuszczelka nazwa1 
                    / pr l1 wskaztu layer szerkol rm c pA pB p0 p1 p2 pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq  pX  (trans (list 0 0) 1 0)
    );setq 


    (command "_LINE" (list 0 0) (list l 0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)
    (command "_LINE" (list (* 0.5 l) (* 0.6 d1)) (list (* 0.5 l)  0) "")
    (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_osie#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)


    (command "_INSERT" sciezkaB#w (list 0 0) "" "" "") (ssadd (entlast) wskazB)


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")
 
(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0 0))(ssadd (entlast) wskazB)
(command "_POINT" (list l 0))(ssadd (entlast) wskazB)
(command "_POINT" (list (* 0.5 l) (* 0.6 d1)))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w

pX
);defun 
