;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w d1#w d2#w a#w b#w o#w w#w h#w l#w czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w kanal#w
		  akcesoria#w  blokOpisUwagi#w listaPX#w i#w p#w pp#w sciezkaB#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w
						  lamelAtryb#w  rozmiarAtryb#w)

		;uwzgldnienie wykonania
		(setq pp#w (cadr (assoc "WentyleFlaktbRWP_Izol" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq  blok#w     (strcat "RWPA1"  (cadr rekord#w)(car rekord#w)) 
		       				    nazwadoz#w (strcat "RWPA-1 "  (cadr rekord#w) "-" (car rekord#w))) )
		      ((member pp#w '("1"))  (setq  blok#w     (strcat "RWPA0"  (cadr rekord#w)(car rekord#w)) 
		       				    nazwadoz#w (strcat "RWPA-0 "  (cadr rekord#w) "-" (car rekord#w))) )
		);cond

		;uwzgldnienie osprztu
		(setq pp#w (cadr (assoc "WentyleFlaktbRWP_Osp" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "A"))
		      ((member pp#w '("1"))  (setq ppp#w "B"))
		      ((member pp#w '("2"))  (setq ppp#w "C"))
		);cond
		(setq  blok#w     (strcat blok#w ppp#w )
		       nazwadoz#w (strcat nazwadoz#w "-" ppp#w ))

		;uwzgldnienie wykonania
		(setq pp#w (cadr (assoc "WentyleFlaktbRWP_Wyk" akcesoria#w)))
		(cond ((member pp#w '("0"))  (setq ppp#w "L"))
		      ((member pp#w '("1"))  (setq ppp#w "P"))
		);cond
		(setq  blok#w     (strcat blok#w ppp#w )
		       nazwadoz#w (strcat nazwadoz#w "-" ppp#w ))

	             ;blok   nazwa      tytul  uwagi         producent
		(list blok#w nazwadoz#w "Regulator wydajnoci" ""  "FLAKT Bovent"  
		      lamelAtryb#w  rozmiarAtryb#w)
		);defun

(wl_err1#w)
;pobiera daNE o elemencie
(setq zwrot#w
(master00#w "WentyleFlaktb" "Regulator wydajnoci" "WentyleFlaktbRWP" "RWPA" "FLAKT Bovent" "      "   "   " 
            "Okno_plus_fb" czyedycja#w "" nil "0"
            "WentyleFlaktb(RWP)" "WentyleFlaktb(RWP_11)"  nil nil nil
                                 "WentyleFlaktb(RWP_21)"  nil nil nil
             (list (list "Osprzt" "WentyleFlaktbRWP_Osp")
		   (list "Wykonanie" "WentyleFlaktbRWP_Wyk")
		   (list "Izolacja" "WentyleFlaktbRWP_Izol"));listaPlikowDanychWyposaenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)


(if zwrot#w  
(progn

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            a#w  (atof (nth 0 rekord#w)) 
	    b#w  (atof (nth 1 rekord#w)) 
	    l#w  620.0

  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w)
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth  6 zwrot#w)
     akcesoria#w (nth 16 zwrot#w))

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   (setq sciezkaB#w (strcat scd#w (caar zwrot#w) "\\" (nth 1 zwrot#w) (car (nth 5 zwrot#w)) "_" ktora#w))

                                     ;lamelAtryb#w rozmiarAtryb#w
   (setq nazwadoz#w (list nazwadoz#w (nth 5 p#w)   (nth 6 p#w) ))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w sciezkaB#w a#w b#w l#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w sciezkaB#w a#w b#w l#w centr#w czyuszczelka#w nazwa#w)))
);cond

;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                  ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                  ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))

;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w nil)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w nil)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleFlaktb")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w sciezkaB#w a#w b#w l#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w sciezkaB#w a#w b#w l#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)         "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)   "");dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list l#w 0) "")
));list/setq

ppzwrot#w
);defun







;procedura porednia rysunkowa
(defun rys21#w (samepunkty#w sciezkaB#w a#w b#w l#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje21#w samepunkty#w sciezkaB#w a#w b#w l#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)         "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)   "");dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list l#w 0) "")
));list/setq

ppzwrot#w
);defun







;procedura rysunkowa
(defun rysuje11#w (samepunkty#w sciezkaB#w a b l centr czyuszczelka nazwa1 
                    / pr l1 l0 wskaztu layer szerkol odstep rm pA pB p0 p1 p2 pX pY pZ styld i lewoprawo)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq pX (trans '(0 0) 1 0)
	  l0 l
          l  80.0
	  b  a)

     (command "_PLINE"  (list 0  (* 0.5 b))     (list 0  (- (* 0.5 b))) 
			(list l0 (- (* 0.5 b))) (list l0 (* 0.5 b)) "_c")
                        (ssadd (entlast) wskazB)
     (command "_CIRCLE" (list 180    (* 0.2 b))  5.0)(ssadd (entlast) wskazB)
     (command "_CIRCLE" (list 180 (- (* 0.2 b))) 5.0)(ssadd (entlast) wskazB)


     (setq b  (* 1.1 a))
     (command "_UCS" "_o" (list 420.0 0))

     (command "_LINE"  (list 0 (* 0.5 b))     (list 0 (- (* 0.5 b))) "")
                       (ssadd (entlast) wskazB)
     (command "_LINE"  (list l (- (* 0.5 b))) (list l (* 0.5 b)) "")
                       (ssadd (entlast) wskazB)

	 (setq  l1 (* 1.2 l)
	       ile (fix (/ b l1))
		 d (- (- (/ b 2) (/ (* ile l1) 2)) (/ b 2))
	       lewoprawo "0")

	 	(repeat ile (progn
			(cond
			((= lewoprawo "0") (progn
	 		    (command "_LINE" (list (* 0.2 l) (+ d (* 0.7 l1))) 
					     (list (* 0.8 l) (+ d (* 0.3 l1))) "")
         		    (ssadd (entlast) wskazB) 
			    (setq lewoprawo "1") ));progn+
			((= lewoprawo "1") (progn
	 		    (command "_LINE" (list (* 0.8 l) (+ d (* 0.7 l1))) 
					     (list (* 0.2 l) (+ d (* 0.3 l1))) "")
         		    (ssadd (entlast) wskazB) 
			    (setq lewoprawo "0") ));progn+
			);cond
	 	(setq d (+ d l1))
	 	));progn/repeat

     (command "_UCS" "_p")


         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0  0) )(ssadd (entlast) wskazB)
(command "_POINT" (list l0 0) )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w


pX
);defun 







;procedura rysunkowa
(defun rysuje21#w (samepunkty#w sciezkaB#w a b l centr czyuszczelka nazwa1 
                    / pr l1 l0 wskaztu layer szerkol odstep rm pA pB p0 p1 p2 pX pY pZ styld i lewoprawo)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq pX (trans '(0 0) 1 0)
	  l0 l
          l  80.0)

     (command "_PLINE"  (list 0  (* 0.5 b))     (list 0  (- (* 0.5 b))) 
			(list l0 (- (* 0.5 b))) (list l0 (* 0.5 b)) "_c")
                        (ssadd (entlast) wskazB)

         (command "_UCS" "_o" (list 420.0 0))

         (command "_LINE"  (list 0 (* 0.5 (* 1.1 b)))     (list 0 (- (* 0.5 (* 1.1 b)))) "")
                           (ssadd (entlast) wskazB)
         (command "_LINE"  (list l (- (* 0.5 (* 1.1 b)))) (list l (* 0.5 (* 1.1 b))) "")
                           (ssadd (entlast) wskazB)

         (command "_PLINE"  (list (* 0.05 l)  (* 0.45 b)) 
			    (list (* 0.05 l)  (- (* 0.45 b))) 
			    (list (* 0.95 l)  (- (* 0.45 b))) 
			    (list (* 0.95 l)  (* 0.45 b)) "_c")
                            (ssadd (entlast) wskazB)	 

         (command "_UCS" "_p")

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list 0  0) )(ssadd (entlast) wskazB)
(command "_POINT" (list l0 0) )(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w


pX
);defun 



