;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w
	          rozm#w a#w b#w c#w
	          czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w p#w listaPX#w
 		  i#w p#w pp#w przekrSpec#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / blok#w nazwadoz#w)
                   ;uszczelka_tu#w zmienna z procedury nadrzdnej master00#w
		  
		   (setq      blok#w (strcat "SGR-DA"  (car rekord#w))
		          nazwadoz#w (strcat "SGR-DA-" (car rekord#w)) )
		   (setq   blok#w     (substr blok#w 1 28))

		   ;;;;(WykonDoNazwy#w)                    ;<<<<<< dodane

	             ;blok   nazwa       tytul   uwagi         producent
		(list blok#w nazwadoz#w "Przepustnica dla SGR" ""  "SPIRO Alnor")
		);defun

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleSpiro" "Przepustnica dla SGR " "WentyleSpiroSGR-DA"  "SGR-DA" "SPIRO Alnor" " "   "   " 
            "Okno_ws" czyedycja#w "" nil "0"
            "WentyleSpiro3(SGR-DA)" "WentyleSpiro3(SGR-DA_11)" "WentyleSpiro3(SGR-DA_12)" nil nil
                                  nil                      nil nil nil 
             nil ;listaPlikowDanychWyposazenia
	     nil ;listaWlasnychGabarytw z opisami
));master00#w/setq
(wyl_err1#w)



(if zwrot#w  
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            rozm#w (atof (car rekord#w))
             a#w (atof (cadr rekord#w))
             b#w (atof (caddr rekord#w))
             c#w (atof (cadddr rekord#w))
	
  czyuszczelka#w (nth 15 zwrot#w)
         centr#w (nth 14 zwrot#w) 
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w) )

   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "13")(setq ppzwrot#w (rys13#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "14")(setq ppzwrot#w (rys14#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "21")(setq ppzwrot#w (rys21#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "22")(setq ppzwrot#w (rys22#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "23")(setq ppzwrot#w (rys23#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
((= ktora#w "24")(setq ppzwrot#w (rys24#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w)))
);cond

;dodanie pola przekroju do kadego punktu z ppzwrot#w
(setq pp#w '())
(foreach i#w (cddr ppzwrot#w)
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "axbmm"))
        (setq p#w  (/  (* a#w b#w) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "axbmm"))
        (setq p#w  (/  (* a#w b#w) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P3" "axbmm"))
        (setq p#w  (/  (* a#w b#w) 1000000.0)     ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w


(if (and pp#w (= (length pp#w) (- (length ppzwrot#w) 2)))
    (setq ppzwrot#w (list (car ppzwrot#w) (cadr ppzwrot#w))
          ppzwrot#w (append ppzwrot#w  pp#w)))



;jesli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)

(wyl_err1#w)

(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w przekrSpec#w)

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleSpiro")


	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun





;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "")   ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list (/ a#w 2) 0) "")
  ;dodany trzeci punkt aby oszuka obliczanie nowododanego obiektu
  (list "P3" "axbmm" (list (- (/ a#w 2)) 0) "")
));list/setq

ppzwrot#w
);defun




;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w / pX#w p00#w) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje12#w samepunkty#w rozm#w a#w b#w c#w centr#w czyuszczelka#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest" (list 0 0)       "")   ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list 0 0)         "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list (/ a#w 2) 0) "")
  ;dodany trzeci punkt aby oszuka obliczanie nowododanego obiektu
  (list "P3" "axbmm" (list (- (/ a#w 2)) 0) "")
));list/setq

ppzwrot#w
);defun






;procedura rysunkowa
(defun rysuje11#w (samepunkty#w rozm  a b c centr czyuszczelka nazwa1 
                    / pr wskaztu layer  b1 pA pB p0 p1 p2 pX pY pZ styld
		    il1 szerw szery sum)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)
    (setq 
          pX (trans '(0 0) 1 0)    
	  b1 (* 0.8 b)
          il1 13
          szerw (/ a (+ (* 2 il1) 1))	  
	  sum szerw
	  szery (* 0.1 b)
    )
    (command "_PLINE"  (list (- (/ a 2)) (- (/ b 2))) (list (- (/ a 2)) (/ b 2))(list (/ a 2) (/ b 2))(list (/ a 2) (- (/ b 2))) "_c")
                                                (ssadd (entlast) wskazB)
    (command "_UCS" "_o" (list (- (/ a 2))(- (- (* 0.5 b) szery)) ))
    (while (< sum (- a szerw))
      (progn
	(command "_pline" (list sum 0)(list (+ sum szerw) 0)(list (+ sum szerw) (- b (* 2 szery)))(list sum (- b (* 2 szery))) "_cl")
	(ssadd (entlast) wskazB)
	(command "_line" (list (+ sum (* 0.3 szerw)) 0)(list (+ sum (* 0.3 szerw)) (- b (* 2 szery))) "")(ssadd (entlast) wskazB)
	(setq sum (+ sum (* 2 szerw)))
      )
    )
    (command "_UCS" "_p")
   
   

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ a 2) 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

;;;;(command "_UCS" "_w")(command "_UCS" "_o" pX)
;;;;;POINTY - wzgldem pX
;;;;(command "_POINT" (list 0 0)      )(ssadd (entlast) wskazB)
;;;;(command "_POINT" (list l 0)  )(ssadd (entlast) wskazB)
;;;;(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w

pX
);defun 





;procedura rysunkowa
(defun rysuje12#w (samepunkty#w rozm  a b c centr czyuszczelka nazwa1 
                    / pr wskaztu layer  b1 pA pB p0 p1 p2 pX pY pZ styld
		    il1  szerw sum dis1 szery ang1 szercos)

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)                          
           layer    (getvar "CLAYER"))    

    (command "_LAYER" "_t" "0" "_s" "0" "")
(command "_UCS" "_w")(command "_UCS" "_o" centr)
  (setq 
          pX (trans '(0 0) 1 0)    
	  b1 (* 0.8 b)
          il1 13
	  szerw (/ a (+ (* 2 il1) 1))	  	  
	  szery (* 0.02 a)
	  ang1 (angle (list (- (/ a 2)) 26)(list (/ a 2) c))
	  sum szerw
	  dis1 (distance (list (- (/ a 2)) 26)(list (/ a 2) c))
    )
    (command "_PLINE"  (list (- (/ a 2)) 0) (list (- (/ a 2)) 26)(list (/ a 2) c)(list (/ a 2) 0) "_c")
                                                (ssadd (entlast) wskazB)
    (command "_UCS" "_o" (list (- (/ a 2)) 26 ))
    (while (< sum (- a szerw))
      (progn
	(setq szercos (/ sum (cos ang1)))
	
	(command "_line"  (polar '(0 0) ang1 szercos ) (polar (polar '(0 0) ang1 szercos) (* 0.5 pi) szery) "")(ssadd (entlast) wskazB)
	(if (< sum (- a (* 3 szerw)))
	       (progn
	            (command "_line"  (polar '(0 0) ang1 (+ szercos (/ szerw (cos ang1))))
		                      (polar (polar '(0 0) ang1 (+ szercos (/ szerw (cos ang1))))(* 1.5 pi) szery) "")
		    (ssadd (entlast) wskazB)
	       )
	)       
	(setq sum (+ sum (* 2 szerw)))
      )
    )
    (command "_UCS" "_p")
  
         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list (/ a 2) 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

;;;;(command "_UCS" "_w")(command "_UCS" "_o" pX)
;;;;;POINTY - wzgldem pX
;;;;(command "_POINT" (list 0 0)  )(ssadd (entlast) wskazB)
;;;;(command "_POINT" (list l 0)  )(ssadd (entlast) wskazB)
;;;;(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w

pX
);defun 

