;-----------------------------------------------------
;procedura zarzadzajca tworzeniem/wstawianiem obiektu
(defun runn#w ( czyedycja#w / zwrot#w ktora#w rekord#w a#w b#w c#w d#w kat#w 
		  czyuszczelka#w centr#w blok#w nazwa#w 
                  nazwadoz#w ppzwrot#w pX#w tblist#w tdata#w samepunkty#w blokOpisUwagi#w listaPX#w czyWyk#w Wyk#w
		  i#w p#w pp#w przekrSpec#w) 

		;lokalna konfiguruje opis tu i w master00#w
		(defun blokOpisUwagi#w ( rekord#w akcesoria#w / a#w b#w c#w d#w kat#w blok#w nazwadoz#w czyWyk#w Wyk#w)

		;zmienne z procedur nadrzdnych:
		;wykonanieURSA-Air_tu#w Czyw_URSA-Air_tu#w 
		;lub zwrot#w
			(cond 
			((= Czyw_URSA-Air_tu#w "1") (setq Wyk#w wykonanieURSA-Air_tu#w))	
			((and zwrot#w (= (cadr (nth 19 zwrot#w)) "1")) (setq Wyk#w (car (nth 19 zwrot#w))))
			(KtoryURSA-Air#w (setq Wyk#w KtoryURSA-Air#w))			
			(T (setq Wyk#w ""))
			);cond
		(cond 	((= Wyk#w "_air")(setq Wyk#w "-S"))
			((= Wyk#w "_altech2")(setq Wyk#w "-A"))
			(T (setq Wyk#w "")) );cond

		(setq blok#w  (strcat "UR-K" Wyk#w (nth 4 rekord#w) (nth 0 rekord#w) (nth 1 rekord#w)
 					    (nth 2 rekord#w) (nth 3 rekord#w) (cadar akcesoria#w))
		      nazwadoz#w  (strcat "UR-K" Wyk#w " " (nth 4 rekord#w) " " (nth 0 rekord#w) "x" (nth 1 rekord#w) 
						     " " (nth 2 rekord#w) " " (nth 3 rekord#w) ))
		(setq blok#w  (substr blok#w 1 28))

	             ;blok   nazwa       tytul    uwagi producent
		(list blok#w nazwadoz#w "Kolano" "" "URSA-Air")
		);defun

(wl_err1#w)
;pobiera dane o elemencie
(setq zwrot#w
(master00#w "WentyleURSA-Air" "Kolano " "WentyleURSA-AirK"  "UR-K"  "URSA-Air" " "   "   " 
            "Okno_wlasneplus2_ur" czyedycja#w "" nil
            "WentyleUrsa-Air(UR-K)"  "WentyleUrsa-Air(UR-K_11)" "WentyleUrsa-Air(UR-K_12)" nil nil
                                      nil nil nil nil
             (list (list "Max.cin./Profil wzmocnie:" "WentyleURSA-Air_Cisnienie"));listaPlikowDanychWyposaenia
	     (list (list "A mm" "500") (list "B mm" "500") (list "C mm" "") (list "D mm" "") (list "Kat" "45")) ;listaWlasnychGabarytw z opisami
            "5" ;ileZlistyDoWlasnych#w 
));master00#w/setq
(wyl_err1#w)

(if zwrot#w  
(progn 

(wl_err1#w)
;przygotowanie danych dla rysunku bloku i do stworzenia bloku
(setq   rekord#w (nth 5 zwrot#w)
            a#w   (atof (nth 0 rekord#w)) b#w (atof (nth 1 rekord#w)) 
            c#w   (atof (nth 2 rekord#w)) d#w (atof (nth 3 rekord#w)) 
	    kat#w (atof (nth 4 rekord#w)) 
         centr#w (nth 14 zwrot#w)
         nazwa#w (strcat (car (nth 12 zwrot#w)) (nth 13 zwrot#w) )
         ktora#w (nth 6 zwrot#w)
     akcesoria#w (nth 15 zwrot#w))

   ;wane tylko przy wstawianiu
   (setq p#w        (blokOpisUwagi#w rekord#w akcesoria#w)
         blok#w     (car p#w)
         nazwadoz#w (cadr p#w))

   ;podmiana niwelujca mylce przydatki literowe w symbolu cigane ywcem z pamitanych wasnych 
   (setq zwrot#w (append (reverse (cddr (reverse zwrot#w))) (list (cons nazwadoz#w (cdr (nth 18 zwrot#w))))
		         (list (car (reverse zwrot#w)))) )

   (setq blok#w (strcase (strcat blok#w "_" ktora#w)))

(setq tblist#w '())
(while (setq tdata#w (tblnext "BLOCK" (not tdata#w)))
(setq tblist#w (append tblist#w (list (cdr (assoc 2 tdata#w))))))

;jesli nie samepunkty - narysowanie bloku, else - zwraca wsprzdne samych punktw
(if (not (member blok#w tblist#w)) 
	    (setq samepunkty#w nil)
	    ;else
	    (setq samepunkty#w T ))

;tworzy rysunek bloku lub same wsprzdne punktw styku
(cond
((= ktora#w "11")(setq ppzwrot#w (rys11#w samepunkty#w a#w b#w c#w d#w kat#w centr#w nazwa#w)))
((= ktora#w "12")(setq ppzwrot#w (rys12#w samepunkty#w a#w b#w c#w d#w kat#w centr#w nazwa#w)))
);cond


;dodanie pola przekroju do kadego punktu z ppzwrot#w
;dla zczek, gdzie zdarzaj si rzyty z obcit list punktw
;std ostatni czon liczcy  przekrSpec#w
(setq pp#w '())
(foreach i#w '(("P1" "axbmm") ("P2" "axbmm"))
(cond
((equal (list (car i#w) (cadr i#w)) '("P1" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                    ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
((equal (list (car i#w) (cadr i#w)) '("P2" "axbmm"))
        (setq p#w  (/ (* a#w b#w) 1000000.0)                   ;[m2]
	      p#w  (rtos p#w 2 6)
	      pp#w (append pp#w (list (append i#w (list p#w))))) )
));cond/foreach i#w
(setq  przekrSpec#w pp#w)


;obliczenie i zaadowanie do rekord#w i zwrot#w pola rozwinicia
(setq p#w (rtos (+ a#w b#w a#w b#w) 2 3));[mm]
(setq pp#w (rtos (* 0.000001 (* (atof p#w)
				(+ c#w d#w)
	         )) 2 3));[m2]
(setq rekord#w (append  rekord#w (list p#w pp#w)))
(setq zwrot#w (append (list (nth 0 zwrot#w) (nth 1 zwrot#w) (nth 2 zwrot#w) (nth 3 zwrot#w))
	(list (append  (nth 4 zwrot#w) (list "obw.mm" "m2")))
	(list (append  (nth 5 zwrot#w) (list p#w pp#w)))
(cddddr (cddr zwrot#w))
));append/setq


;jeli nie samepunkty - tworzy blok
(blokuje00#w samepunkty#w blok#w ppzwrot#w zwrot#w)


    ;lokalna 
    ;rozwinicie do specjalnych zestawie dla URSAiru, korzysta z wymiarw z procedury nadrzdnej
    (defun URSAirProcedura#w ( / p#w pp#w dlosi#w sumaOsi#w zewPoprz#w wewPoprz#w
				zwrot#w gr#w xx#w)

    (setq ;;;; pp#w (* (* 2 (+ (* 0.001 a#w) (* 0.001 b#w) 0.2)) (+ (* 0.001 c#w) (* 0.001 d#w))) ) ;[m2]
           pp#w  (* (+ 0.19 (* 2 (+ (* 0.001 a#w) (* 0.001 b#w)))) (+ (* 0.001 c#w) (* 0.001 d#w)) ) );[m2]

    (setq gr#w  (atoi GrURSA-Air#w)          ;[m]
	  sumaOsi#w  (* 0.001 (+ c#w d#w))
		xx#w (* 2 (+ (+ a#w gr#w gr#w) (+ b#w gr#w gr#w)))
	  zewPoprz#w (* 0.001 xx#w)          ;zawsze minus jedno
		xx#w (* 2 (+ (* 1.1 (+ a#w gr#w gr#w)) (+ b#w gr#w gr#w)))
	  wewPoprz#w (* 0.001 (* 1 xx#w))
     );setq
		     
    (setq zwrot#w (list "" pp#w "SUMAOSI" sumaOsi#w "ZEWPOPRZ" zewPoprz#w "WEWPOPRZ" wewPoprz#w))
    );defun lokalnej

(setq ppzwrot#w (append (list (URSAirProcedura#w)) ppzwrot#w))



(wyl_err1#w)



(if czyedycja#w (progn
		;odczytuje punkty PX dopisdopisane ew.wczeniej do edytowanego
		(setq listaPX#w (doprzeniesieniaPX#w (car czyedycja#w)))
		;wstawia blok
		(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		           (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
		;dopisuje wczeniej odczytane PX
		(if listaPX#w (zprzeniesienia#w (entlast) listaPX#w))
		);progn
	;else
	(progn

	;wstawia blok		
	(if tylkoNaSciezce#w		
	(insert01#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w 
		    (cadr czyedycja#w) (caddr czyedycja#w) czyedycja#w przekrSpec#w)
	;else
	(insert00#w nazwadoz#w blok#w ppzwrot#w zwrot#w rekord#w przekrSpec#w))

	;ustawia zmienne globalne
	(globset00#w zwrot#w)

		;export do pliku danych wsplnych nakadki
		(dotxt#w "Wentyle")

		;export do pliku danych tego systemu zczek
		(dotxt00#w "WentyleURSA-Air")

	;rysuje odnonik
	(cond ((= strzal#w "1") (odno_strzalka#w))
	      ( T               (odno_linia#w))  )

	));progn/if not czyedycja

));progn/if
		
(princ)
);defun







;procedura porednia rysunkowa
(defun rys11#w (samepunkty#w a#w b#w c#w d#w kat#w centr#w nazwa#w / pX#w p00#w ) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w a#w b#w c#w d#w kat#w centr#w nazwa#w))
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest"  (list 0 0)        "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list (* c#w (cos (* (- 90 kat#w) (/ pi 180)))) (* c#w (sin (* (- 90 kat#w) (/ pi 180)))) )      
				       "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list 0 (- d#w)) "")
));list/setq

ppzwrot#w
);defun






;procedura porednia rysunkowa
(defun rys12#w (samepunkty#w a#w b#w c#w d#w kat#w centr#w nazwa#w / pX#w p00#w ) 
;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
    (progn
    (setq pX#w (rysuje11#w samepunkty#w a#w b#w c#w d#w kat#w centr#w nazwa#w))
    (command "_UCS" "_w")(command "_UCS" "_o" pX#w)
       (setq p00#w ( trans pX#w 0 1))
       (command "_MIRRTEXT" "0")
       (command "_MIRROR"  wskazB "" p00#w (list (car p00#w) (+ (cadr p00#w) 100)) "_Y")
    (command "_UCS" "_p")(command "_UCS" "_p")
    ));progn/if

;dodaje punkty styku lub jeli tylko punkty styku, bez rysowania
(setq ppzwrot#w 
(list pX#w  	       	                   ;punkt wstawienia bloku, nil jeli tylko punkty bez rysunku
  (list "P0" "jest"  (list 0 0)        "") ;punkt przecicia osi jeli jest, jeli brak to  "P0" "brak" '(0 0)
  (list "P1" "axbmm" (list (- (* c#w (cos (* (- 90 kat#w) (/ pi 180))))) (* c#w (sin (* (- 90 kat#w) (/ pi 180)))) )      
				       "") ;dalej punkty styku poprzedzone symbolem punktu i symbolem wymiaru 
  (list "P2" "axbmm" (list 0 (- d#w)) "")
));list/setq

ppzwrot#w
);defun









;procedura rysunkowa
(defun rysuje11#w (samepunkty#w a b c d kat centr nazwa1 
                    / gr seg col pr aa bb x c1 c2 c3 c4 s1 s2 s3 s4 pa pa1 pb pb1 
		      wskaztu layer szerkol pX pY pZ styld )

;jeli z rysowaniem elementw bloku
(if (not samepunkty#w)
(progn
    ;wskazB - zbir wskaza zmienna globalna
    (setq  wskazB   nil  wskazB   (ssadd)
           layer    (getvar "CLAYER")
	   gr	(atoi GrURSA-Air#w)
	   seg	(atoi SzerURSA-Air#w)
	   col  (atoi ColorURSA-Air#w))

    (command "_LAYER" "_t" "0" "_s" "0" "")

    (command "_LAYER" "_t" layer_zarys "_s" layer_zarys "")

    (command "_UCS" "_w")(command "_UCS" "_o" centr)

    (setq pX (trans (list 0 0) 1 0))

			(command "_UCS" "_z" (- kat))
			(setq c1 (trans (list (- (+ (/ a 2) gr))       c) 1 0)
			      c2 (trans (list (- (+ (/ a 2) gr)) 0) 1 0) )
			(setq s1 (trans (list (+ (/ a 2) gr)           c) 1 0)
			      s2 (trans (list (+ (/ a 2) gr) 0) 1 0) )	
			(setq c3 (trans (list (- (/ a 2)) c) 1 0)
			      c4 (trans (list (- (/ a 2)) 0) 1 0) )
			(setq s3 (trans (list (/ a 2) c) 1 0)
			      s4 (trans (list (/ a 2) 0) 1 0) )			
			(command "_UCS" "_p")

		(setq 
		pa (trans (inters (trans c1 0 1)(trans c2 0 1)
		        (list (- (+ (/ a 2) gr)) 0) (list (- (+ (/ a 2) gr)) 100) nil)
                    1 0)
                pa1 (trans (inters (trans s1 0 1)(trans s2 0 1)
		        (list (+ (/ a 2) gr) 0) (list (+ (/ a 2) gr) 100) nil)
                    1 0)
		pb (trans (inters (trans c3 0 1)(trans c4 0 1)
		        (list (- (/ a 2) ) 0) (list (- (/ a 2) ) 100) nil)
                    1 0)
                pb1 (trans (inters (trans s3 0 1)(trans s4 0 1)
		        (list (/ a 2) 0) (list (/ a 2) 100) nil)
                    1 0)
		);setq

    (command "_PLINE"  	(list (+ (/ a 2) gr) (- d)) (list (- (+ (/ a 2) gr)) (- d)) (trans pa 0 1) (trans c1 0 1) 
			(trans s1 0 1) (trans pa1 0 1)  "_c")
		       	(ssadd (entlast) wskazB)

    (command "_PLINE"  (list (/ a 2) (- d)) (trans pb1 0 1) (trans s3 0 1)  "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

    (command "_PLINE"  (list (- (/ a 2)) (- d)) (trans pb 0 1) (trans c3 0 1)  "")
		     (setq pr (entget (entlast)))
	             (setq pr (append pr (list  (cons 62 col) (cons 6 "HIDDEN") )))
		     (entmod pr) (ssadd (entlast) wskazB)

    (if (czy_wzmoc_Ob#w a#w b#w) (progn  (command "_UCS" "_o" (list (* c (cos (* (- 90 kat) (/ pi 180))))(* c (sin (* (- 90 kat) (/ pi 180)))) ))
					 (command "_UCS" "_z" (- 90 kat))
					 (wzmocnienieObwodowe#w  (list 0 0) -25 a) (command "_UCS" "_p")(command "_UCS" "_p")
				 (command "_UCS" "_o" (list 0 (- d)))
				 (command "_UCS" "_z" "-90")(wzmocnienieObwodowe#w (list 0 0) -25 a) (command "_UCS" "_p")(command "_UCS" "_p")
				 ));progn/if

         (setq styld (getvar "TEXTSTYLE"))
         (setvar "AFLAGS" 0)
         (command "_ATTDEF" "_p" "" "WENTYLE" "" nazwa1  "_s" styl_wentyle#w
                            "_j" "_bl" (list 0 0) wtext#w "0")
         (setq pr (entget (entlast)))(setq pr (subst (cons 8 layer_atrybut#w)(assoc 8 pr) pr))(entmod pr)
                                                               (ssadd (entlast) wskazB)  
         (command "_-STYLE" styld "" "" "" "" "" "" "")
         (command "_UCS" "_p")(command "_UCS" "_p")

(command "_UCS" "_w")(command "_UCS" "_o" pX)
;POINTY - wzgldem pX
(command "_POINT" (list (* c (cos (* (- 90 kat) (/ pi 180)))) 
			(* c (sin (* (- 90 kat) (/ pi 180)))) ) )(ssadd (entlast) wskazB)
(command "_POINT" (list 0 (- d)))(ssadd (entlast) wskazB)
(command "_UCS" "_p")(command "_UCS" "_p")
(command "_LAYER" "_s" layer "") 

));progn/if not samepunkty#w

pX
);defun 








;druga lokalna procedura sprawdzajca gabaryty wasne, korzysta ze zmiennych procedury nadrzdnej
(defun czy_masterMoj#w ( / gr seg text1#w text2#w pxx#w j#w listaWlasnych_tu#w a b c d kat aa bb x p pp ppp)
(progn

;przeniesienie zmiennej procedury nadrzdnej jeli wywoanie z procedury master00#w
(if (not rekord#w)(setq listaWlasnych_tu#w listaWlasnych#w))

(if (and listaWlasnych_tu#w (not text1#w)) (progn
(cond 
((not listaWlas#w)(setq text1#w "Wypenij pola rozmiarw lub wybierz z listy !..."))
(T (progn
   (setq pxx#w '())(foreach j#w listaWlas#w (if (and j#w (/= j#w "")) 
                                                (setq pxx#w (append pxx#w (list j#w)))))
   (if (and listaWlasnych_tu#w (/= (length listaWlasnych_tu#w) (length pxx#w)))
                                (setq text1#w "Brakuje wpisu w jednym z pl rozmiarw !..."))
   ));progn+
);cond
));progn/if

;dla uruchomienia z poziomu procedury dopasowania kanau i zczki
(if rekord#w (setq pxx#w rekord#w listaWlasnych_tu#w T))

	   (setq gr   (atoi GrURSA-Air#w)
	   	 seg  (atoi SzerURSA-Air#w))

(if (and listaWlasnych_tu#w (not text1#w))
	(progn
        (cond
        ((sprawdz_lcalk#w (nth 0 pxx#w) 100 2400)
              (setq text1#w "Bdny wpis lub przekroczone granice 100 do 2400mm w polu A [mm] !..."))
        ((sprawdz_lcalk#w (nth 1 pxx#w) 100 2400)
              (setq text1#w "Bdny wpis lub przekroczone granice 100 do 2400mm  w polu B [mm] !..."))
        ((sprawdz_lcalk#w (nth 2 pxx#w) 100 10000)
              (setq text1#w "Bdny wpis lub przekroczone granice w polu C [mm] !..."))
        ((sprawdz_lcalk#w (nth 3 pxx#w) 100 10000)
              (setq text1#w "Bdny wpis lub przekroczone granice w polu D [mm] !..."))
        ((sprawdz_lcalk#w (nth 4 pxx#w) 1 90)
              (setq text1#w "Bdny wpis lub przekroczone granice w polu Kt [mm] !..."))
	)));progn/if


(if (and listaWlasnych_tu#w (not text1#w))
	(progn
        (setq a (atof (nth 0 pxx#w)) b (atof (nth 1 pxx#w)) 
 	      c (atof (nth 2 pxx#w)) d (atof (nth 3 pxx#w)) 
              kat (atof (nth 4 pxx#w)))
	(setq aa (* (+ gr (/ a 2)) (/ (sin (* (/ kat 2) (/ pi 180))) (cos (* (/ kat 2) (/ pi 180))) )))

        ;uwaga na pocztku cond wszystkie generujce text1#w
	(cond
	((< (- c aa) 100)(setq text1#w "Prosty odcinek na kocu zczki wraz ze skosem ma by >= 100mm !..."))
	((> (+ c aa) seg)(setq text1#w "Najwiksza dugo segmentu wylotu <w stron C> nie moe przekroczy 1170 mm !..."))

	((< (- d aa) 100)(setq text1#w "Prosty odcinek na kocu zczki wraz ze skosem ma by >= 100mm !..."))
	((> (+ d aa) seg)(setq text1#w "Najwiksza dugo segmentu wylotu <w stron D> nie moe przekroczy 1170 mm !..."))
        );cond
	));progn/if

(if (not rekord#w) (if text1#w (set_tile "error" text1#w)))
text1#w

));progn/defun



		;procedura oblicza wartoci wymiarw mniej wanych dla potrzeb procedury master...
		;wykorzystuje i generuje zmienne tej nadrzdnej procedury					
		(defun przeliczTuTu#w ( control#w / a#w b#w kat#w)
		(cond
		((= control#w 1)(progn
			  (setq a#w (atof wlasne0_tu#w)
				b#w (atof wlasne1_tu#w)
			      kat#w (atof wlasne4_tu#w))
			  (setq kat#w (/ (* (/ kat#w 2) pi) 180.0)
				wlasne2_tu#w (rtos (+ (* (+ (/ a#w 2) 30.0) (/ (sin kat#w)(cos kat#w))) 101) 2 0) ;C mm
				wlasne3_tu#w (rtos (+ (* (+ (/ a#w 2) 30.0) (/ (sin kat#w)(cos kat#w))) 101) 2 0) ;D mm
			  );setq
			));progn+

		(T (progn (setq wlasne2_tu#w "" ;C mm
				wlasne3_tu#w "" ;D mm
			  );setq
			));progn+
		);cond
		(princ)
		);defun



